#include <algorithm>
#include <iterator>
#include <iostream>
#include <vector>
#include <math.h>
#include <ext/functional>

namespace ext=__gnu_cxx;

using namespace std;
using ext::compose1;

const double pi = 3.14159265358979323846;

int main() {
	double a[]={0.0,30.0,60.0,90.0};
	vector<double> v(a,a+4);

	copy(v.begin(),v.end(),
		ostream_iterator<double>(cout," "));
	cout << endl;

	vector<double> v1;

	transform(v.begin(),v.end(),back_inserter(v1),
		compose1(ptr_fun(sin),
		bind2nd(multiplies<double>(),pi/180.0)));

	copy(v1.begin(),v1.end(),
		ostream_iterator<double>(cout," "));
	cout << endl;

	return 0;
}

